#!/usr/bin/perl -w

# RemoteControl v0.10 - An mIRC-esque Remote system.
# Alex Roberts <bse@error.fsnet.co.uk> 1999

# mIRC remotes look like this (thanks to ninevese)
#  on 1:text:*ninevah-*:#:/msg $chan there's no ninevah- here
#  on 1:ACTION:revives nine:#:/msg $chan have some respect for the dead!

# remotes here look like..
# hot-word:response[:#channel]

# the response can include:
#	<NICK>	:	the nick of the person who said the hotword
#	<CHAN>	:	the name of the channel the hotword was mentioned in


IRC::print "\0035Loading remote script (0.10) \003\n";
IRC::add_message_handler ("PRIVMSG", "msg_handler");

# Reload is broken, seems to destroy the remotes array
#IRC::add_command_handler("reloadremote", "reload");

# Location of the remote's list
$remotelist = "/home/bse/.xchat/remotecontrol";

# load the remotes list

if (open(REMOTES, $remotelist)) {
	IRC::print ("\002Loading the Remotes List - $remotelist\002\n\n");
	$list = "";
	$list = <REMOTES>;
	@remotes = split('\n',$list);
	close(REMOTES);
} else {
	IRC::print("\002I couldn't open $remotelist \002\n\n");
}


sub msg_handler {

	my $line = shift (@_);
	$line =~ /:(.*)!(\S+) PRIVMSG (.*) :(.*)/i;
	
	$thenick = $1;
	$thechan = $3;
	$thetext = $4;
	@words = split(' ', $4);

	#foreach my $testwords (@words) {

	foreach my $remote (@remotes) {
			
		@message = split (/:/, $remote);
			
		if ($thetext =~ /$message[0]/i) {
			
			# display the actual message
			if ($thetext !~ /ACTION/) {
		    	IRC::print "\0032<\003$thenick\0032>\003 $thetext\n";
		    } else {
		    	$thetext =~ s/ACTION//;
		    	IRC::print "\0032*\003 $thenick$thetext\n";
		    }
		    
			# substitute any hot words in the message (nicks, channels, etc)
		    $message[1] =~ s/<NICK>/$thenick/;
		    $message[1] =~ s/<CHAN>/$thechan/;
		    # check if message is channel limited
		    if ($message[2]) {
		    	if ($message[2] =~ /$thechan/) {
					# say the response to the message
					IRC::command "$message[1]";
				
					return 1;
				} else {
					return 1;
				}
			}
			# message isnt channel limited, lets say it then..
			IRC::command "$message[1]";
			return 1;
		}
	}
	#}
	return 0;
}


sub reload {
	# load the remotes list

	if (open(REMOTES, $remotelist)) {
		IRC::print ("\002Reloading the Remotes List - $remotelist\002\n\n");
		$list = "";
		$list = <REMOTES>;
		@remotes = split('\n',$list);
		close(REMOTES);
	} else {
		IRC::print("\002I couldn't open $remotelist \002\n\n");
	}
}